#maintain a list of
#soap lists

package require tdom
global _soapdoc

proc soap.init {} {
    set soap(startup) [clock format [clock seconds]]
    nsv_array set _soapLists [array get soap]
}

proc soap.reload {} {
    ns_eval source /home/pjaol/work/tcl_lib/nsdtcl/nssoap.tcl
}

proc soap.addProc { procName } {
    nsv_set _soapLists proc,$procName 1
}


proc soap.isSoapProc { procName } {
    catch {
	return nsv_get _soapList proc,$procName
    } err
    return 0
}


proc soap.execute { procName {args} } {

    set re ""
    soap.createEnvelope
    soap.createBody $procName

    catch {
	set results [eval "$procName $args"]
	set re [soap.createResponse $procName $results]
    } err
    
    if {![string length $re] } {
	soap.createFault $procName $err soap:Server ; #internal error code
    }
    global _soapdoc
    return [$_soapdoc asXML]
}


proc soap.createFault { procName err errorCode} {
    global _soapdoc
    set root [$_soapdoc documentElement]
    set soapbody [$root getElementsByTagName soap:Body]

    set fault [$_soapdoc createElement soap:Fault]

    #written as text, as not dynamic
    set faultCode "<faultcode>$errorCode</faultcode>"
    set faultString "<faultstring>[ns_quotehtml $err]</faultstring>"

    $fault appendXML $faultCode
    $fault appendXML $faultString
    $soapbody appendChild $fault
}

proc soap.createEnvelope {} {
    global _soapdoc
    dom createDocumentNS http://www.w3.org/2001/12/soap-envelope soap:Envelope _soapdoc
}


proc soap.createResponse { procName {results} } {

    global _soapdoc
    
    set root [$_soapdoc documentElement]
    set soapbody [$root getElementsByTagName soap:Body] ;#possible bug in tdom,
	                                                 #xpath query returns null if body is empty
    set response [$_soapdoc createElement "m:${procName}Response"]
    set responseNode [$soapbody appendChild $response]
    
    #screwie results
    foreach i $results {
	set child [$_soapdoc createElement "string"]
	$child setAttribute "xsi:type" "xsd:string"
	$child appendFromList [list "#text" [ns_quotehtml $i]]
	$responseNode appendChild $child
    }
    return 1
}

proc soap.createBody { procName } {

    global _soapdoc
    
    set root [$_soapdoc documentElement]
    
    set body [$_soapdoc createElement "soap:Body"]
    set bodyNode [$root appendChild $body]
}

soap.init
